// pages/zzdy/pages/scList/scList.js
import {
    filePrintSave
} from "../../../../api/zzdy"
Page({

    /**
     * 页面的初始数据
     */
    data: {
        selected: [],
        touchS: null,
        now: null,
        ani: null,
        margin: null,
        old: 0,
        uuid: ""
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        let that = this
        if (options) {
            that.init(options)
        }
    },

    // 初始化
    init(e) {
        let that = this
        if (e.select) {
            var selected = JSON.parse(decodeURI(e.select))
            selected = [...selected, ...that.data.selected]
            that.setData({
                selected: selected
            })
        }
        if (e.fpList) {
            console.log(e.fpList)
            var fpList = JSON.parse(decodeURI(e.fpList))
            console.log(fpList)
            fpList = [...fpList, ...that.data.selected]
            that.setData({
                selected: fpList
            })
        }
        if (e.uuid) {
            that.setData({
                uuid: e.uuid
            })
        }
    },

    // 添加文档
    addWd() {
        let that = this
        var selected = that.data.selected
        wx.chooseMessageFile({
            count: 10,
            type: 'file',
            success(res) {
                selected = [...selected, ...res.tempFiles]
                that.setData({
                    selected: selected
                })
            }
        })
    },

    // 预览文档
    yulan(e) {
        let that = this
        var item = e.currentTarget.dataset.item
        console.log(`${wx.env.USER_DATA_PATH}/fppdf/${item}`)
        wx.openDocument({
            filePath: item.path || `${wx.env.USER_DATA_PATH}/fppdf/${item}`,
            success: function (res) {},
            fail: err => {
                if (item.path) {
                    if (item.path.split('.')[item.path.split('.').length - 1] == 'jpg' ||
                        item.path.split('.')[item.path.split('.').length - 1] == 'jpeg' || item.path.split('.')[item.path.split('.').length - 1] == 'png') {
                        wx.previewImage({
                            urls: [item.path],
                        })
                    }

                } else {
                    wx.showToast({
                        title: '不支持此文件预览',
                        icon: "error"
                    })
                }
            }
        })
    },

    // 手指按下
    mstart(e) {
        let that = this
        var margin = that.data.margin
        var index = e.currentTarget.dataset.index
        if (margin == -60 && index == that.data.now) {
            that.setData({
                margin: -60,
                mai: null,
                touchS: e.touches[0].clientX,
                old: -60
            })
        } else {
            that.setData({
                margin: 0,
                touchS: e.touches[0].clientX,
                old: 0,
                now: index
            })
        }
    },
    // 手指滑动
    mmove(e) {
        let that = this
        var old = that.data.old
        var index = e.currentTarget.dataset.index
        var touchS = that.data.touchS - old
        var touchM = e.touches[0].clientX
        var margin = touchM - touchS
        that.setData({
            margin: margin,
            now: index
        })

    },
    // 手指松开
    mend(e) {
        let that = this
        var margin = that.data.margin
        var now = that.data.now
        if (margin < -60) {
            that.setData({
                margin: -60,
                ani: now
            })
        } else {
            that.setData({
                now: null,
                margin: null,
                ani: now
            })
        }
        setTimeout(() => {
            that.setData({
                ani: null
            })
        }, 200);
    },

    // 删除
    delateBtn(e) {
        let that = this
        var index = e.currentTarget.dataset.index
        var selected = that.data.selected
        selected.splice(index, 1)
        that.setData({
            selected: selected,
            margin: null,
            mai: null,
            touchS: null,
            clientY: null,
            now: null
        })
    },
    // 上传文件
    async upload() {
        wx.showLoading({
            title: '正在上传...',
        })
        let that = this
        let select = that.data.selected
        for (let i = 0; i < select.length; i++) {
            console.log(i)
            var a = await that.uploadImg(select[i])
            console.log(a)
        }
        wx.showModal({
            title: '成功',
            content: '已全部发送自助机，正在打印...',
            showCancel: false,
            confirmText: "完成"
        })
        wx.hideLoading()
    },
    uploadImg(e) {
        let that = this
        return new Promise((resolve, rejects) => {
            let path = e.path || e
            let data = {
                uuid: String(that.data.uuid),
                wxId: wx.getStorageSync('openid')
            }
            filePrintSave(data, path).then(res => {
                let datas = JSON.parse(res)
                resolve(data)
                if (datas.code != 200) {
                    wx.showToast({
                        title: data.message || data.msg,
                        icon: "none"
                    })
                }
            })
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        var that = this
        const fs = wx.getFileSystemManager()
        wx.getStorage({
            key: "FPLIST",
            success: res => {
                let files = []
                let count = 0
                for (let i = 0; i < res.data.length; i++) {
                    wx.downloadFile({
                        url: res.data[i],
                        success: result => {
                            console.log(result)
                            let filePath = wx.env.USER_DATA_PATH + '/fppdf/' + new Date().getTime() + '.pdf'
                            fs.saveFile({
                                tempFilePath: result.tempFilePath,
                                filePath: filePath,
                                success: () => {}
                            })
                            fs.readdir({
                                dirPath: `${wx.env.USER_DATA_PATH}/fppdf`,
                                success(res2) {
                                    count = count + 1
                                    if (count == res.data.length) {
                                        let nowfiles = []
                                        res2.files.map(item => {
                                            var obj = {
                                                path: `${wx.env.USER_DATA_PATH}/fppdf/` + item,
                                                name: item
                                            }
                                            nowfiles.push(obj)
                                        })
                                        files = [...nowfiles, ...that.data.selected]
                                        that.setData({
                                            selected: files
                                        })
                                    }
                                },
                                fail(err) {
                                    console.error(err)
                                }
                            })
                        }
                    })
                }
                wx.removeStorage({
                    key: 'FPLIST',
                })
            }
        })
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {
        const fs = wx.getFileSystemManager()
        fs.rmdir({
            dirPath: `${wx.env.USER_DATA_PATH}/fppdf`,
            recursive: true,
            success(res) {
                console.log(res)
            },
            fail(res) {
                console.error(res)
            }
        })
    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})