// pages/zzdy/pages/xcsc/xcsc.js
import {
    filePrintSave
} from "../../../../api/zzdy"
Page({

    /**
     * 页面的初始数据
     */
    data: {
        selected: [],
        uuid: ""
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        let that = this
        that.init(options)
    },

    init(e) {
        let that = this
        if (e) {
            if (e.uuid) {
                that.setData({
                    uuid: e.uuid
                })
            } else {
                wx.showToast({
                    title: '未获取到id',
                    icon: "none"
                })
            }
        }
    },

    // 添加图片
    addPicture() {
        var that = this
        wx.showActionSheet({
            itemList: ["拍摄", "手机相册", "微信聊天记录"],
            success(e) {
                if (e.tapIndex === 0) {
                    wx.chooseMedia({
                        count: 10,
                        mediaType: ['image'],
                        sourceType: ['camera'],
                        maxDuration: 30,
                        camera: 'back',
                        success(res) {
                            var selected = [...res.tempFiles, ...that.data.selected]
                            that.setData({
                                selected: selected
                            })
                            that.sfDy()
                        }
                    })
                } else if (e.tapIndex === 1) {
                    wx.chooseMedia({
                        count: 10,
                        mediaType: ['image'],
                        sourceType: ['album'],
                        maxDuration: 30,
                        camera: 'back',
                        success(res) {
                            var selected = [...res.tempFiles, ...that.data.selected]
                            that.setData({
                                selected: selected
                            })
                            that.sfDy()
                        }
                    })
                } else if (e.tapIndex === 2) {
                    wx.chooseMessageFile({
                        count: 10,
                        type: 'image',
                        success(res) {
                            console.log(res)
                            var selected = [...res.tempFiles, ...that.data.selected]
                            that.setData({
                                selected: selected
                            })
                            that.sfDy()
                        }
                    })
                }
            }
        })
    },

    // 判断是否超过
    sfDy() {
        let that = this
        var selected = that.data.selected
        if (selected.length > 10) {
            selected.splice(10, selected.length - 10)
        }
        that.setData({
            selected: selected
        })
    },

    // 删除已选择的图片
    delate(e) {
        let that = this
        var index = e.currentTarget.dataset.index
        var selected = that.data.selected
        selected.splice(index, 1)
        that.setData({
            selected: selected
        })
    },

    // 上传图片
    async upload() {
        wx.showLoading({
            title: '正在上传...',
        })
        let that = this
        let select = that.data.selected
        for (let i = 0; i < select.length; i++) {
            console.log(i)
            var a = await that.uploadImg(select[i])
            console.log(a)
        }
        wx.showModal({
            title: '成功',
            content: '已全部发送自助机，正在打印...',
            showCancel: false,
            confirmText: "完成"
        })
        wx.hideLoading()
    },
    uploadImg(e) {
        let that = this
        return new Promise((resolve, rejects) => {
            let path = e.tempFilePath
            let data = {
                uuid: String(that.data.uuid),
                wxId: wx.getStorageSync('openid')
            }
            filePrintSave(data, path).then(res => {
                let datas = JSON.parse(res)
                resolve(data)
                if (datas.code != 200) {
                    wx.showToast({
                        title: data.message || data.msg,
                        icon: "none"
                    })
                }
            })
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})